searchNodes=[{"doc":"Patch - Ergonomic Mocking for Elixir Patch makes it easy to mock one or more functions in a module returning a value or executing custom logic. Patches and Spies allow tests to assert or refute that function calls have been made. Using Patch is as easy as adding a single line to your test case. use Patch After this all the patch functions will be available, see the function documentation for details.","ref":"Patch.html","title":"Patch","type":"module"},{"doc":"Asserts that the given module and function has been called with any arity. patch ( Example , :function , :patch ) assert_any_call ( Example , :function ) # fails Example . function ( 1 , 2 , 3 ) assert_any_call ( Example , :function ) # passes","ref":"Patch.html#assert_any_call/2","title":"Patch.assert_any_call/2","type":"function"},{"doc":"Given a call will assert that a matching call was observed by the patched function. The call can use the special sentinal :_ as a wildcard match. patch ( Example , :function , :patch ) Example . function ( 1 , 2 , 3 ) assert_called Example . function ( 1 , 2 , 3 ) # passes assert_called Example . function ( 1 , :_ , 3 ) # passes assert_called Example . function ( 4 , 5 , 6 ) # fails assert_called Example . function ( 4 , :_ , 6 ) # fails","ref":"Patch.html#assert_called/1","title":"Patch.assert_called/1","type":"macro"},{"doc":"Expose can be used to turn private functions into public functions for the purpose of testing them. To expose every private function as a public function, pass the sentinel value :all . expose ( Example , :all ) Otherwise pass a Keyword.t(arity) of the functions to expose. For example, if one wanted to expose private_function/1 and private_function/2 . expose ( Example , [ private_function : 1 , private_function : 2 ] )","ref":"Patch.html#expose/2","title":"Patch.expose/2","type":"function"},{"doc":"Fakes out a module with an alternative implementation. The real module can still be accessed with real/1 . For example, if your project has the module Example.Datastore and there's a fake available in the testing environment named Example.Test.InMemoryDatastore the following table describes which calls are executed by which code before and after faking with the following call. fake ( Example.Datastore , Example.Test.InMemoryDatastore ) Calling Code Responding Module before fake/2 Responding Module after fake/2 Example.Datastore.get/1 Example.Datastore.get/1 Example.Test.InMemoryDatastore.get/1 Example.Test.InMemoryDatastore.get/1 Example.Test.InMemoryDatastore.get/1 Example.Test.InMemoryDatastore.get/1 real(Example.Datastore).get/1 (UndefinedFunctionError) Example.Datastore.get/1 The fake module can use the renamed module to access the original implementation.","ref":"Patch.html#fake/2","title":"Patch.fake/2","type":"function"},{"doc":"Get all the observed calls to a module. These calls are expressed as a {name, argument} tuple and can either be provided in ascending (oldest first) or descending (newest first) order by providing a sorting of :asc or :desc , respectively. Example . example ( 1 , 2 , 3 ) Example . function ( :a ) assert history ( Example ) == [ { :example , [ 1 , 2 , 3 ] } , { :function , [ :a ] } ] assert history ( Example , :desc ) == [ { :function , [ :a ] } , { :example , [ 1 , 2 , 3 ] } ] For asserting or refuting that a call happened the assert_called/1 , assert_any_call/2 , refute_called/1 , and refute_any_call/2 functions provide a more convenient API.","ref":"Patch.html#history/2","title":"Patch.history/2","type":"function"},{"doc":"Convenience function for updating the state of a running process. Uses the Access module to traverse the state structure according to the given keys . Structs have special handling so that they can be updated without having to implement the Access behavior. For example to inject the value :injected under the key :key in the map found under the key :map . inject ( target , [ :map , :key ] , :injected )","ref":"Patch.html#inject/3","title":"Patch.inject/3","type":"function"},{"doc":"Starts a listener process. Each listener should provide a unique tag that will be used when forwarding messages to the test process. When used on a named process, this is sufficient to begin intercepting all messages to the named process. listen ( :listener , Example ) When used on an unnamed process, the process that is spawned will forward any messages to the caller and target process but any processes holding a reference to the old pid will need to be updated. inject/3 can be used to inject a listener into a running process. { :ok , listener } = listen ( :listener , original ) inject ( target , :original , listener )","ref":"Patch.html#listen/3","title":"Patch.listen/3","type":"function"},{"doc":"Patches a function in a module When called with a function the function will be called instead of the original function and its results returned. patch ( Example , :function , fn arg -&gt; { :mock , arg } end ) assert Example . function ( :test ) == { :mock , :test } To handle multiple arities create a callable/2 with the :list option and the arguments will be wrapped to the function in a list. patch ( Example , :function , callable ( fn [ ] -&gt; :zero [ a ] -&gt; { :one , a } [ a , b ] -&gt; { :two , a , b } end , :list ) ) assert Example . function ( ) == :zero assert Example . function ( 1 ) == { :one , 1 } assert Example . function ( 1 , 2 ) == { :two , 1 , 2 } To provide a function as a literal value to be returned, use the scalar/1 function. patch ( Example , :function , scalar ( fn arg -&gt; { :mock , arg } end ) ) callable = Example . function ( ) assert callable . ( :test ) == { :mock , :test } The function cycle/1 can be given a list which will be infinitely cycled when the function is called. patch ( Example , :function , cycle ( [ 1 , 2 , 3 ] ) ) assert Example . function ( ) == 1 assert Example . function ( ) == 2 assert Example . function ( ) == 3 assert Example . function ( ) == 1 assert Example . function ( ) == 2 assert Example . function ( ) == 3 assert Example . function ( ) == 1 The function raises/1 can be used to raise/1 a RuntimeError when the function is called. patch ( Example , :function , raises ( &quot;patched&quot; ) ) assert_raise RuntimeError , &quot;patched&quot; , fn -&gt; Example . function ( ) end The function raises/2 can be used to raise/2 any exception with any attributes when the function is called. patch ( Example , :function , raises ( ArgumentError , message : &quot;patched&quot; ) ) assert_raise ArgumentError , &quot;patched&quot; , fn -&gt; Example . function ( ) end The function sequence/1 can be given a list which will be used until a singal value is remaining, the remaining value will be returned on all subsequent calls. patch ( Example , :function , sequence ( [ 1 , 2 , 3 ] ) ) assert Example . function ( ) == 1 assert Example . function ( ) == 2 assert Example . function ( ) == 3 assert Example . function ( ) == 3 assert Example . function ( ) == 3 assert Example . function ( ) == 3 assert Example . function ( ) == 3 The function throws/1 can be given a value to throw/1 when the function is called. patch ( Example , :function , throws ( :patched ) ) assert catch_throw ( Example . function ( ) ) == :patched Any other value will be returned as a literal scalar value when the function is called. patch ( Example , :function , :patched ) assert Example . function ( ) == :patched","ref":"Patch.html#patch/3","title":"Patch.patch/3","type":"function"},{"doc":"Suppress warnings for using exposed private functions in tests. Patch allows you to make a private function public, but this happens dynamically at test time. The Elixir Compiler will flag calls to exposed functions as a warning. One way around this is to change the normal function call into an apply/3 but this is cumbersome and makes tests harder to read. This macro just rewrites a normal looking call into an apply/3 so the compiler won't complain about calling an exposed function. expose ( Example , :all ) patch ( Example , :private_function , :patched ) assert Example . private_function ( ) == :patched # Compiler will warn about call to undefined function assert apply ( Example , :private_function , [ ] ) == :patched # Compiler will not warn assert private ( Example . private_function ( ) ) == :patched # Same as previous line, but looks nicer.","ref":"Patch.html#private/1","title":"Patch.private/1","type":"macro"},{"doc":"Gets the real module name for a fake. This is useful for Fakes that want to defer some part of the functionality back to the real module. def Example do def calculate ( a ) do # ...snip some complex calculations... result end end def Example.Fake do import Patch , only : [ real : 1 ] def calculate ( a ) do real_result = real ( Example ) . calculate ( a ) { :fake , real_result } end end","ref":"Patch.html#real/1","title":"Patch.real/1","type":"function"},{"doc":"Refutes that the given module and function has been called with any arity. patch ( Example , :function , :patch ) refute_any_call ( Example , :function ) # passes Example . function ( 1 , 2 , 3 ) refute_any_call ( Example , :function ) # fails","ref":"Patch.html#refute_any_call/2","title":"Patch.refute_any_call/2","type":"function"},{"doc":"Given a call will refute that a matching call was observed by the patched function. The call can use the special sentinal :_ as a wildcard match. patch ( Example , :function , :patch ) Example . function ( 1 , 2 , 3 ) refute_called Example . function ( 4 , 5 , 6 ) # passes refute_called Example . function ( 4 , :_ , 6 ) # passes refute_called Example . function ( 1 , 2 , 3 ) # fails refute_called Example . function ( 1 , :_ , 3 ) # fails","ref":"Patch.html#refute_called/1","title":"Patch.refute_called/1","type":"macro"},{"doc":"Remove any mocks or spies from the given module original = Example . example ( ) patch ( Example , :example , :patched ) assert Example . example ( ) == :patched restore ( Example ) assert Example . example ( ) == original","ref":"Patch.html#restore/1","title":"Patch.restore/1","type":"function"},{"doc":"Spies on the provided module Once a module has been spied on the calls to that module can be asserted / refuted without changing the behavior of the module. spy ( Example ) Example . example ( 1 , 2 , 3 ) assert_called Example . example ( 1 , 2 , 3 ) # passes","ref":"Patch.html#spy/1","title":"Patch.spy/1","type":"function"},{"doc":"","ref":"Patch.Listener.html","title":"Patch.Listener","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Patch.Listener.html#child_spec/1","title":"Patch.Listener.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Patch.Listener.html#init/1","title":"Patch.Listener.init/1","type":"function"},{"doc":"","ref":"Patch.Listener.html#start_link/4","title":"Patch.Listener.start_link/4","type":"function"},{"doc":"","ref":"Patch.Listener.html#target/1","title":"Patch.Listener.target/1","type":"function"},{"doc":"Option to control whether or not to capture GenServer.call replies. Defaults to true","ref":"Patch.Listener.html#t:capture_replies_option/0","title":"Patch.Listener.capture_replies_option/0","type":"type"},{"doc":"Sum-type of all valid options","ref":"Patch.Listener.html#t:option/0","title":"Patch.Listener.option/0","type":"type"},{"doc":"","ref":"Patch.Listener.html#t:t/0","title":"Patch.Listener.t/0","type":"type"},{"doc":"Listeners are started with a tag so the listening process can differentiate between multiple listeners.","ref":"Patch.Listener.html#t:tag/0","title":"Patch.Listener.tag/0","type":"type"},{"doc":"Listeners listen to a target.","ref":"Patch.Listener.html#t:target/0","title":"Patch.Listener.target/0","type":"type"},{"doc":"Option to control how long the listener should wait for GenServer.call Value is either the number of milliseconds to wait or the :infinity atom. If capture_replies is set to false this setting has no effect. Defaults to 5000","ref":"Patch.Listener.html#t:timeout_option/0","title":"Patch.Listener.timeout_option/0","type":"type"},{"doc":"","ref":"Patch.Listener.Supervisor.html","title":"Patch.Listener.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Patch.Listener.Supervisor.html#child_spec/1","title":"Patch.Listener.Supervisor.child_spec/1","type":"function"},{"doc":"Callback implementation for DynamicSupervisor.init/1 .","ref":"Patch.Listener.Supervisor.html#init/1","title":"Patch.Listener.Supervisor.init/1","type":"function"},{"doc":"","ref":"Patch.Listener.Supervisor.html#start_child/4","title":"Patch.Listener.Supervisor.start_child/4","type":"function"},{"doc":"","ref":"Patch.Listener.Supervisor.html#start_link/1","title":"Patch.Listener.Supervisor.start_link/1","type":"function"},{"doc":"","ref":"Patch.Mock.html","title":"Patch.Mock","type":"module"},{"doc":"Checks to see if a function with the given name has been called in the given module. This function uses the Mock's history to check, if the history is limited or disabled then calls that have happened may report back as never having happened.","ref":"Patch.Mock.html#called?/2","title":"Patch.Mock.called?/2","type":"function"},{"doc":"Checks to see if a fucntion with the given name has been called in the given module with the given arguments. The arguments list can include the wildcard atom, :_ to match any argument in that position. This function uses the Mock's history to check, if the history is limited or disabled then calls tht have happened may report back as never having happened.","ref":"Patch.Mock.html#called?/3","title":"Patch.Mock.called?/3","type":"function"},{"doc":"Expose private functions in a module. If the module is not already mocked, calling this function will mock it.","ref":"Patch.Mock.html#expose/2","title":"Patch.Mock.expose/2","type":"function"},{"doc":"Gets the call history for a module. If the module is not already mocked, this function returns an empty new history.","ref":"Patch.Mock.html#history/1","title":"Patch.Mock.history/1","type":"function"},{"doc":"Mocks the given module. Mocking a module accepts two options, see the option/0 type in this module for details.","ref":"Patch.Mock.html#module/2","title":"Patch.Mock.module/2","type":"function"},{"doc":"Registers a mock value for a function. If the module is not already mocked, this function will mock it with no private functions exposed.","ref":"Patch.Mock.html#register/3","title":"Patch.Mock.register/3","type":"function"},{"doc":"Restores a module to pre-patch functionality. If the module is not already mocked, this function no-ops.","ref":"Patch.Mock.html#restore/1","title":"Patch.Mock.restore/1","type":"function"},{"doc":"What exposures should be made in a module. :public will only expose the public functions :all will expose both public and private functions A list of exports can be provided, they will be added to the :public functions.","ref":"Patch.Mock.html#t:exposes/0","title":"Patch.Mock.exposes/0","type":"type"},{"doc":"The exposes option controls if any private functions should be exposed. The default is :public .","ref":"Patch.Mock.html#t:exposes_option/0","title":"Patch.Mock.exposes_option/0","type":"type"},{"doc":"This history_limit option controls how large of a history a mock should store It defaults to :infinity which will store an unlimited history.","ref":"Patch.Mock.html#t:history_limit_option/0","title":"Patch.Mock.history_limit_option/0","type":"type"},{"doc":"Sum-type of all valid options","ref":"Patch.Mock.html#t:option/0","title":"Patch.Mock.option/0","type":"type"},{"doc":"","ref":"Patch.Mock.History.html","title":"Patch.Mock.History","type":"module"},{"doc":"","ref":"Patch.Mock.History.html#entries/2","title":"Patch.Mock.History.entries/2","type":"function"},{"doc":"","ref":"Patch.Mock.History.html#new/1","title":"Patch.Mock.History.new/1","type":"function"},{"doc":"","ref":"Patch.Mock.History.html#put/3","title":"Patch.Mock.History.put/3","type":"function"},{"doc":"","ref":"Patch.Mock.History.html#t:arguments/0","title":"Patch.Mock.History.arguments/0","type":"type"},{"doc":"","ref":"Patch.Mock.History.html#t:entry/0","title":"Patch.Mock.History.entry/0","type":"type"},{"doc":"","ref":"Patch.Mock.History.html#t:name/0","title":"Patch.Mock.History.name/0","type":"type"},{"doc":"","ref":"Patch.Mock.History.html#t:t/0","title":"Patch.Mock.History.t/0","type":"type"},{"doc":"","ref":"Patch.Mock.Naming.html","title":"Patch.Mock.Naming","type":"module"},{"doc":"Canonical name for the delegate module for a provided module.","ref":"Patch.Mock.Naming.html#delegate/1","title":"Patch.Mock.Naming.delegate/1","type":"function"},{"doc":"Canonical name for the facade module for a provided module. The facade module simply takes on the name of the provided module.","ref":"Patch.Mock.Naming.html#facade/1","title":"Patch.Mock.Naming.facade/1","type":"function"},{"doc":"Canonical name for the original module for a provided module.","ref":"Patch.Mock.Naming.html#original/1","title":"Patch.Mock.Naming.original/1","type":"function"},{"doc":"Canonical name for the server process for a provided module.","ref":"Patch.Mock.Naming.html#server/1","title":"Patch.Mock.Naming.server/1","type":"function"},{"doc":"","ref":"Patch.Mock.Server.html","title":"Patch.Mock.Server","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Patch.Mock.Server.html#child_spec/1","title":"Patch.Mock.Server.child_spec/1","type":"function"},{"doc":"Delegates a call to a mocked module through the server so it can optionally respond with a mock value.","ref":"Patch.Mock.Server.html#delegate/3","title":"Patch.Mock.Server.delegate/3","type":"function"},{"doc":"","ref":"Patch.Mock.Server.html#do_restore/1","title":"Patch.Mock.Server.do_restore/1","type":"function"},{"doc":"","ref":"Patch.Mock.Server.html#expose/2","title":"Patch.Mock.Server.expose/2","type":"function"},{"doc":"Retrieves the call history for a mock","ref":"Patch.Mock.Server.html#history/1","title":"Patch.Mock.Server.history/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Patch.Mock.Server.html#init/1","title":"Patch.Mock.Server.init/1","type":"function"},{"doc":"Registers a mock value to be returned whenever the specified function is called on the module.","ref":"Patch.Mock.Server.html#register/3","title":"Patch.Mock.Server.register/3","type":"function"},{"doc":"Restores a module to its original state.","ref":"Patch.Mock.Server.html#restore/1","title":"Patch.Mock.Server.restore/1","type":"function"},{"doc":"","ref":"Patch.Mock.Server.html#start_link/2","title":"Patch.Mock.Server.start_link/2","type":"function"},{"doc":"Sum-type of all valid options","ref":"Patch.Mock.Server.html#t:option/0","title":"Patch.Mock.Server.option/0","type":"type"},{"doc":"","ref":"Patch.Mock.Server.html#t:t/0","title":"Patch.Mock.Server.t/0","type":"type"},{"doc":"","ref":"Patch.Mock.Supervisor.html","title":"Patch.Mock.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Patch.Mock.Supervisor.html#child_spec/1","title":"Patch.Mock.Supervisor.child_spec/1","type":"function"},{"doc":"Callback implementation for DynamicSupervisor.init/1 .","ref":"Patch.Mock.Supervisor.html#init/1","title":"Patch.Mock.Supervisor.init/1","type":"function"},{"doc":"","ref":"Patch.Mock.Supervisor.html#start_child/2","title":"Patch.Mock.Supervisor.start_child/2","type":"function"},{"doc":"","ref":"Patch.Mock.Supervisor.html#start_link/1","title":"Patch.Mock.Supervisor.start_link/1","type":"function"},{"doc":"Patch mocks out modules by generating mock modules and recompiling them for a target module. Patch's approach to mocking a module provides some powerful affordances. Private functions can be mocked. Internal function calls are effected by mocks regardless of the function's visibility without having to change the way code is written. Private functions can be optionally exposed in the facade to make it possible to test a private function directly without changing its visibility in code. Mocking Strategy There are 4 logical modules and 1 GenServer that are involved when mocking a module. The 4 logical modules: target - The module to be mocked. facade - The target module is replaced by a facade module that intercepts all external calls and redirects them to the delegate module. original - The target module is preserved as the original module, with the important transformation that all local calls are redirected to the delegate module. delegate - This module is responsible for checking with the server to see if a call is mocked and should be intercepted. If so, the mock value is returned, otherwise the original function is called. Each target module has an associated GenServer, a Patch.Mock.Server that has keeps state about the history of function calls and holds the mock data to be returned on interception. See Patch.Mock.Server for more information. Example Target Module To better understand how Patch works, consider the following example module. defmodule Example do def public_function ( argument_1 , argument_2 ) do { :public , private_function ( argument_1 , argument_2 ) } end defp private_function ( argument_1 , argument_2 ) do { :private , argument_1 , argument_2 } end end facade module The facade module is automatically generated based off the exports of the target module. It takes on the name of the provided module. For each exported function, a function is generated in the facade module that calls the delegate module. defmodule Example do def public_function ( argument_1 , argument_2 ) do Patch.Mock.Delegate.For.Example . public_function ( argument_1 , argument_2 ) end end delegate module The delegate module is automatically generated based off all the functions of the target module. It takes on a name based off the target module, see Patch.Mock.Naming.delegate/1 . For each function, a function is generated in the delegate module that calls Patch.Mock.Server.delegate/3 delegating to the server named for the target module, see Patch.Mock.Naming.server/1 . defmodule Patch.Mock.Delegate.For.Example do def public_function ( argument_1 , argument_2 ) do Patch.Mock.Server . delegate ( Patch.Mock.Server.For.Example , :public_function , [ argument_1 , argument_2 ] ) end def private_function ( argument_1 , argument_2 ) do Patch.Mock.Server . delegate ( Patch.Mock.Server.For.Example , :private_function , [ argument_1 , argument_2 ] ) end end original module The original module takes on a name based off the provided module, see Patch.Mock.Naming.original/1 . The code is transformed in the following ways. All local calls are converted into remote calls to the delegate module. All functions are exported defmodule Patch.Mock.Original.For.Example do def public_function ( argument_1 , argument_2 ) do { :public , Patch.Mock.Delegate.For.Example . private_function ( argument_1 , argument_2 ) } end def private_function ( argument_1 , argument_2 ) do { :private , argument_1 , argument_2 } end end External Function Calls First, let's examine how calls from outside the module are treated. Public Function Calls Code calling Example.public_function/2 has the following call flow. [Caller] -&gt; facade -&gt; delegate -&gt; server -&gt; mocked? -&gt; yes (Intercepted) [Mock Value] &lt;----------------------------|----' -&gt; no -&gt; original (Run Original Code) [Original Value] &lt;--------------------------------------' Calling a public funtion will either return the mocked value if it exists, or fall back to calling the original function. Private Function Calls Code calling Example.private_function/2 has the following call flow. [Caller] --------------------------&gt; facade [UndefinedFunctionError] &lt;-----' Calling a private function continues to be an error from the external caller's point of view. The expose option does allow the facade to expose private functions, in those cases the call flow just follows the public call flow. Internal Calls Next, let's examine how calls from outside the module are treated. Public Function Calls Code in the original module calling public functions have their code transformed to call the delegate module. original -&gt; delegate -&gt; server -&gt; mocked? -&gt; yes (Intercepted) [Mock Value] &lt;------------------|----' -&gt; no -&gt; original (Run Original Code) [Original Value] &lt;----------------------------' Since the call is redirected to the delegate , calling a public funtion will either return the mocked value if it exists, or fall back to calling the original function. Private Function Call Flow Code in the original module calling private functions have their code transformed to call the delegate module original -&gt; delegate -&gt; server -&gt; mocked? -&gt; yes (Intercepted) [Mock Value] &lt;------------------|----' -&gt; no -&gt; original (Run Original Code) [Original Value] &lt;----------------------------' Since the call is redirected to the delegate , calling a private funtion will either return the mocked value if it exists, or fall back to calling the original function. Code Generation For additional details on how Code Generation works, see the Patch.Mock.Code.Generate module.","ref":"Patch.Mock.Code.html","title":"Patch.Mock.Code","type":"module"},{"doc":"","ref":"Patch.Mock.Code.html#abstract_forms/1","title":"Patch.Mock.Code.abstract_forms/1","type":"function"},{"doc":"","ref":"Patch.Mock.Code.html#attributes/1","title":"Patch.Mock.Code.attributes/1","type":"function"},{"doc":"Classifies an exported mfa into one of the following classifications :builtin - Export is a BIF. :generated - Export is a generated function. :normal - Export is a user defined function.","ref":"Patch.Mock.Code.html#classify_export/3","title":"Patch.Mock.Code.classify_export/3","type":"function"},{"doc":"","ref":"Patch.Mock.Code.html#compile/2","title":"Patch.Mock.Code.compile/2","type":"function"},{"doc":"","ref":"Patch.Mock.Code.html#compiler_options/1","title":"Patch.Mock.Code.compiler_options/1","type":"function"},{"doc":"","ref":"Patch.Mock.Code.html#exports/3","title":"Patch.Mock.Code.exports/3","type":"function"},{"doc":"Given a module and a list of exports filters the list of exports to those that have the given classification. See classify_export/3 for information about export classification","ref":"Patch.Mock.Code.html#filter_exports/3","title":"Patch.Mock.Code.filter_exports/3","type":"function"},{"doc":"Mocks a module by generating a set of modules based on the target module. The target module's unchanged abstract_form is returned on success.","ref":"Patch.Mock.Code.html#module/2","title":"Patch.Mock.Code.module/2","type":"function"},{"doc":"","ref":"Patch.Mock.Code.html#purge/1","title":"Patch.Mock.Code.purge/1","type":"function"},{"doc":"","ref":"Patch.Mock.Code.html#stick_module/1","title":"Patch.Mock.Code.stick_module/1","type":"function"},{"doc":"","ref":"Patch.Mock.Code.html#unstick_module/1","title":"Patch.Mock.Code.unstick_module/1","type":"function"},{"doc":"","ref":"Patch.Mock.Code.html#t:chunk_error/0","title":"Patch.Mock.Code.chunk_error/0","type":"type"},{"doc":"","ref":"Patch.Mock.Code.html#t:compiler_option/0","title":"Patch.Mock.Code.compiler_option/0","type":"type"},{"doc":"","ref":"Patch.Mock.Code.html#t:export_classification/0","title":"Patch.Mock.Code.export_classification/0","type":"type"},{"doc":"","ref":"Patch.Mock.Code.html#t:exports/0","title":"Patch.Mock.Code.exports/0","type":"type"},{"doc":"","ref":"Patch.Mock.Code.html#t:form/0","title":"Patch.Mock.Code.form/0","type":"type"},{"doc":"Sum-type of all valid options","ref":"Patch.Mock.Code.html#t:option/0","title":"Patch.Mock.Code.option/0","type":"type"},{"doc":"This module provides the ability to generate derivative modules based on a target module. This module delegates code generation to purpose specific Generator modules, see those modules for additional details on how specific generation works. Patch.Mock.Code.Generators.Delegate for how delegate modules are generated Patch.Mock.Code.Generators.Facade for how facade modules are generated Patch.Mock.Code.Generators.Original for how original modules are generated","ref":"Patch.Mock.Code.Generate.html","title":"Patch.Mock.Code.Generate","type":"module"},{"doc":"See Patch.Mock.Code.Generators.Delegate.generate/3 .","ref":"Patch.Mock.Code.Generate.html#delegate/3","title":"Patch.Mock.Code.Generate.delegate/3","type":"function"},{"doc":"See Patch.Mock.Code.Generators.Facade.generate/3 .","ref":"Patch.Mock.Code.Generate.html#facade/3","title":"Patch.Mock.Code.Generate.facade/3","type":"function"},{"doc":"See Patch.Mock.Code.Generators.Original.generate/3 .","ref":"Patch.Mock.Code.Generate.html#original/3","title":"Patch.Mock.Code.Generate.original/3","type":"function"},{"doc":"This module provides the ability to query abstract forms. This module delegates queries to purpose specific Queries modules, see those modules for additional details on how specific queries work. Patch.Mock.Code.Queries.Exports for how exports are queried Patch.Mock.Code.Queries.Functions for how functions are queried","ref":"Patch.Mock.Code.Query.html","title":"Patch.Mock.Code.Query","type":"module"},{"doc":"See Patch.Mock.Code.Queries.Exports.query/1 .","ref":"Patch.Mock.Code.Query.html#exports/1","title":"Patch.Mock.Code.Query.exports/1","type":"function"},{"doc":"See Patch.Mock.Code.Queries.Functions.query/1 .","ref":"Patch.Mock.Code.Query.html#functions/1","title":"Patch.Mock.Code.Query.functions/1","type":"function"},{"doc":"This module provides the ability to transform abstract forms. This module delegates transformation to purpose specific Transforms modules, see those modules for additional details on how specific transformations work. Patch.Mock.Code.Transforms.Clean for how a module is prepared for generation. Patch.Mock.Code.Transforms.Export for how exports are rewritten Patch.Mock.Code.Transforms.Filter for how functions are filtered Patch.Mock.Code.Transforms.Remote for how local calls are made remote Patch.Mock.Code.Transforms.Rename for how a module is renamed","ref":"Patch.Mock.Code.Transform.html","title":"Patch.Mock.Code.Transform","type":"module"},{"doc":"See Patch.Mock.Code.Transforms.Clean.transform/1 .","ref":"Patch.Mock.Code.Transform.html#clean/1","title":"Patch.Mock.Code.Transform.clean/1","type":"function"},{"doc":"See Patch.Mock.Code.Transforms.Export.transform/2 .","ref":"Patch.Mock.Code.Transform.html#export/2","title":"Patch.Mock.Code.Transform.export/2","type":"function"},{"doc":"See Patch.Mock.Code.Transforms.Filter.transform/2 .","ref":"Patch.Mock.Code.Transform.html#filter/2","title":"Patch.Mock.Code.Transform.filter/2","type":"function"},{"doc":"See Patch.Mock.Code.Transforms.Remote.transform/2 .","ref":"Patch.Mock.Code.Transform.html#remote/2","title":"Patch.Mock.Code.Transform.remote/2","type":"function"},{"doc":"See Patch.Mock.Code.Transforms.Rename.transform/2 .","ref":"Patch.Mock.Code.Transform.html#rename/2","title":"Patch.Mock.Code.Transform.rename/2","type":"function"},{"doc":"","ref":"Patch.Mock.Code.Unit.html","title":"Patch.Mock.Code.Unit","type":"module"},{"doc":"","ref":"Patch.Mock.Code.Unit.html#purge/1","title":"Patch.Mock.Code.Unit.purge/1","type":"function"},{"doc":"","ref":"Patch.Mock.Code.Unit.html#restore/1","title":"Patch.Mock.Code.Unit.restore/1","type":"function"},{"doc":"","ref":"Patch.Mock.Code.Unit.html#t:t/0","title":"Patch.Mock.Code.Unit.t/0","type":"type"},{"doc":"Generator for delegate modules. delegate modules are generated by taking the target module and creating a stub function for each function in the module that calls the Patch.Mock.Server 's delegate/3 function. The delegate module will also expose every function in the module regardless of the original visibility.","ref":"Patch.Mock.Code.Generators.Delegate.html","title":"Patch.Mock.Code.Generators.Delegate","type":"module"},{"doc":"Generates a new delegate module based on the forms of a provided module.","ref":"Patch.Mock.Code.Generators.Delegate.html#generate/3","title":"Patch.Mock.Code.Generators.Delegate.generate/3","type":"function"},{"doc":"Generator for facade modules. facade modules are generated by taking the target module and creating a stub function for each function in the module that calls the delegate modules corresponding function. The facade module can optionally expose private functions as public.","ref":"Patch.Mock.Code.Generators.Facade.html","title":"Patch.Mock.Code.Generators.Facade","type":"module"},{"doc":"Generates a new facade module based on the forms of the provided module.","ref":"Patch.Mock.Code.Generators.Facade.html#generate/3","title":"Patch.Mock.Code.Generators.Facade.generate/3","type":"function"},{"doc":"","ref":"Patch.Mock.Code.Generators.Original.html","title":"Patch.Mock.Code.Generators.Original","type":"module"},{"doc":"Generates a new original module based on the forms of the provided module.","ref":"Patch.Mock.Code.Generators.Original.html#generate/3","title":"Patch.Mock.Code.Generators.Original.generate/3","type":"function"},{"doc":"","ref":"Patch.Mock.Code.Queries.Exports.html","title":"Patch.Mock.Code.Queries.Exports","type":"module"},{"doc":"Queries the provided forms for the exported functions.","ref":"Patch.Mock.Code.Queries.Exports.html#query/1","title":"Patch.Mock.Code.Queries.Exports.query/1","type":"function"},{"doc":"","ref":"Patch.Mock.Code.Queries.Functions.html","title":"Patch.Mock.Code.Queries.Functions","type":"module"},{"doc":"Queries the provided forms for all defined functions.","ref":"Patch.Mock.Code.Queries.Functions.html#query/1","title":"Patch.Mock.Code.Queries.Functions.query/1","type":"function"},{"doc":"Cleans abstract form to prepare it for subsequent generation. Everything except for the module attribute, exports, and functions are removed.","ref":"Patch.Mock.Code.Transforms.Clean.html","title":"Patch.Mock.Code.Transforms.Clean","type":"module"},{"doc":"","ref":"Patch.Mock.Code.Transforms.Clean.html#transform/1","title":"Patch.Mock.Code.Transforms.Clean.transform/1","type":"function"},{"doc":"","ref":"Patch.Mock.Code.Transforms.Export.html","title":"Patch.Mock.Code.Transforms.Export","type":"module"},{"doc":"Transforms the provided forms to export the given list of functions.","ref":"Patch.Mock.Code.Transforms.Export.html#transform/2","title":"Patch.Mock.Code.Transforms.Export.transform/2","type":"function"},{"doc":"Filters the functions and specifications in a module to the exports provided.","ref":"Patch.Mock.Code.Transforms.Filter.html","title":"Patch.Mock.Code.Transforms.Filter","type":"module"},{"doc":"","ref":"Patch.Mock.Code.Transforms.Filter.html#transform/2","title":"Patch.Mock.Code.Transforms.Filter.transform/2","type":"function"},{"doc":"","ref":"Patch.Mock.Code.Transforms.Remote.html","title":"Patch.Mock.Code.Transforms.Remote","type":"module"},{"doc":"Transforms the provided forms to rewrite any local call into a remote call to the provided module .","ref":"Patch.Mock.Code.Transforms.Remote.html#transform/2","title":"Patch.Mock.Code.Transforms.Remote.transform/2","type":"function"},{"doc":"","ref":"Patch.Mock.Code.Transforms.Rename.html","title":"Patch.Mock.Code.Transforms.Rename","type":"module"},{"doc":"Transforms the provided forms to rename the module to the provided module name.","ref":"Patch.Mock.Code.Transforms.Rename.html#transform/2","title":"Patch.Mock.Code.Transforms.Rename.transform/2","type":"function"},{"doc":"Interface for generating mock values. In a test this module is imported into the test and so using this module directly is not necessary.","ref":"Patch.Mock.Value.html","title":"Patch.Mock.Value","type":"module"},{"doc":"Advances the given value. Sequences and Cycles both have meaningful advances, all other values types this acts as a no-op.","ref":"Patch.Mock.Value.html#advance/1","title":"Patch.Mock.Value.advance/1","type":"function"},{"doc":"Create a new Values.Callable to be used as the mock value. When a patched function has a Values.Callable as its mock value, it will invoke the callable with the arguments to the patched function on every invocation to generate a new value to return. patch ( Example , :example , callable ( fn arg -&gt; { :patched , arg } end ) ) assert Example . example ( 1 ) == { :patched , 1 } # passes assert Example . example ( 2 ) == { :patched , 2 } # passes assert Example . example ( 3 ) == { :patched , 3 } # passes Any function literal will automatically be promoted into a Values.Callable unless it is wrapped in a scalar/1 call. patch ( Example , :example , fn arg -&gt; { :patched , arg } end ) assert Example . example ( 1 ) == { :patched , 1 } # passes assert Example . example ( 2 ) == { :patched , 2 } # passes assert Example . example ( 3 ) == { :patched , 3 } # passes callable/2 allows the test author to provide a dispatch_mode of either :apply or :list . When :apply is used the function is called with the same arity of the patched function. When :list is used the function is always called with a single argument, a list of arguments to the patched function. patch ( Example , :example , callable ( fn a , b , c -&gt; { :patched , a , b , c } end ) , :apply ) assert Example . example ( 1 , 2 , 3 ) == { :patched , 1 , 2 , 3 } # passes assert_raise BadArityError , fn -&gt; Example . example ( :test ) end Compare this with using list dispatch patch ( Example , :example , callable ( fn [ a , b , c ] -&gt; { :patched , a , b , c } [ a ] -&gt; { :patched , a } end , :list ) ) assert Example . example ( 1 , 2 , 3 ) == { :patched , 1 , 2 , 3 } # passes assert Example . example ( 1 ) == { :patched , 1 } # passes When multiple arity support is needed, use :list dispatch.","ref":"Patch.Mock.Value.html#callable/2","title":"Patch.Mock.Value.callable/2","type":"function"},{"doc":"Create a new Values.Cycle to be used as the mock value. When a patched function has a Values.Cycle as its mock value, it will provide the first value in the cycle and then move the first value to the end of the cycle on every invocation. Consider a function patched with cycle([1, 2, 3]) via the following code patch ( Example , :example , cycle ( [ 1 , 2 , 3 ] ) ) Invocation Cycle Before Call Return Value Cycle After Call 1 [1, 2, 3] 1 [2, 3, 1] 2 [2, 3, 1] 2 [3, 1, 2] 3 [3, 1, 2] 3 [1, 2, 3] 4 [1, 2, 3] 1 [2, 3, 1] 5 [2, 3, 1] 2 [3, 1, 2] 6 [3, 1, 2] 3 [1, 2, 3] 7 [1, 2, 3] 1 [2, 3, 1] We could continue the above table forever since the cycle will repeat endlessly. Cycles can contain callable/1,2 , raise/1,2 and throw/1 mock values.","ref":"Patch.Mock.Value.html#cycle/1","title":"Patch.Mock.Value.cycle/1","type":"function"},{"doc":"Guard that checks whether a value is a proper Values module","ref":"Patch.Mock.Value.html#is_value/1","title":"Patch.Mock.Value.is_value/1","type":"macro"},{"doc":"Generate the next return value and advance the underlying value.","ref":"Patch.Mock.Value.html#next/2","title":"Patch.Mock.Value.next/2","type":"function"},{"doc":"Creates a special Values.Callable to be used as a mock value. This callable ignores the arguments passed in and unconditionally raises a RuntimeError with the given message. patch ( Example , :example , raises ( &quot;patched&quot; ) ) assert_raise RuntimeError , &quot;patched&quot; , fn -&gt; Example . example ( ) end","ref":"Patch.Mock.Value.html#raises/1","title":"Patch.Mock.Value.raises/1","type":"function"},{"doc":"Creates a special Values.Callable to be used as a mock value. This callable ignores the arguments passed in and unconditionally raises the specified exception with the given attributes. patch ( Example , :example , raises ( ArgumentError , message : &quot;patched&quot; ) ) assert_raise ArgumentError , &quot;patched&quot; , fn -&gt; Example . example ( ) end","ref":"Patch.Mock.Value.html#raises/2","title":"Patch.Mock.Value.raises/2","type":"function"},{"doc":"Creates a new Values.Scalar to be used as the mock value. When a patched function has a Values.Scalar as its mock value, it will provide the scalar value on every invocation patch ( Example , :example , scalar ( :patched ) ) assert Example . example ( ) == :patched # passes assert Example . example ( ) == :patched # passes assert Example . example ( ) == :patched # passes When patching with any term that isn't a function, it will automatically be promoted into a Values.Scalar . patch ( Example , :example , :patched ) assert Example . example ( ) == :patched # passes assert Example . example ( ) == :patched # passes assert Example . example ( ) == :patched # passes Since functions are always automatically promoted to Values.Callable , if a function is meant as a scalar value it must be wrapped in a call to scalar/1 . patch ( Example , :get_name_normalizer , scalar ( &amp; String . downcase / 1 ) ) assert Example . get_name_normalizer == &amp; String . downcase / 1 # passes","ref":"Patch.Mock.Value.html#scalar/1","title":"Patch.Mock.Value.scalar/1","type":"function"},{"doc":"Creates a new Values.Sequence to be used as a mock value. When a patched function has a Values.Sequence as its mock value, it will provide the first value in the sequence as the return value and then discard the first value. Once the sequence is down to a final value it will be retained and returned on every subsequent invocation. Consider a function patched with sequence([1, 2, 3]) via the following code patch ( Example , :example , sequence ( [ 1 , 2 , 3 ] ) ) Invocation Sequence Before Call Return Value Sequence After Call 1 [1, 2, 3] 1 [2, 3] 2 [2, 3] 2 [3] 3 [3] 3 [3] 4 [3] 3 [3] 5 [3] 3 [3] We could continue the above table forever since the sequence will continue to return the last value endlessly. Sequences can contain callable/1,2 , raise/1,2 and throw/1 mock values. There is one special behavior of sequence, and that's an empty sequence, which always returns the value nil on every invocation. If the test author would like to simulate an exhaustable sequence, one that returns a set number of items and then responds to every other call with nil , they can simply add a nil as the last element in the sequence patch ( Example , :example , sequence ( [ 1 , 2 , 3 , nil ] ) Invocation Sequence Before Call Return Value Sequence After Call 1 [1, 2, 3, nil] 1 [2, 3, nil] 2 [2, 3, nil] 2 [3, nil] 3 [3, nil] 3 [nil] 4 [nil] nil [nil] 5 [nil] nil [nil]","ref":"Patch.Mock.Value.html#sequence/1","title":"Patch.Mock.Value.sequence/1","type":"function"},{"doc":"Creates a special Values.Callable to be used as a mock value. This callable ignores the arguments passed in and unconditionally throws the given value. patch ( Example , :example , throws ( :patched ) ) assert catch_throw ( Example . example ( ) ) == :patched","ref":"Patch.Mock.Value.html#throws/1","title":"Patch.Mock.Value.throws/1","type":"function"},{"doc":"","ref":"Patch.Mock.Value.html#t:t/0","title":"Patch.Mock.Value.t/0","type":"type"},{"doc":"","ref":"Patch.Mock.Values.Callable.html","title":"Patch.Mock.Values.Callable","type":"module"},{"doc":"","ref":"Patch.Mock.Values.Callable.html#advance/1","title":"Patch.Mock.Values.Callable.advance/1","type":"function"},{"doc":"","ref":"Patch.Mock.Values.Callable.html#new/2","title":"Patch.Mock.Values.Callable.new/2","type":"function"},{"doc":"","ref":"Patch.Mock.Values.Callable.html#next/2","title":"Patch.Mock.Values.Callable.next/2","type":"function"},{"doc":"","ref":"Patch.Mock.Values.Callable.html#t:dispatch_mode/0","title":"Patch.Mock.Values.Callable.dispatch_mode/0","type":"type"},{"doc":"","ref":"Patch.Mock.Values.Callable.html#t:t/0","title":"Patch.Mock.Values.Callable.t/0","type":"type"},{"doc":"","ref":"Patch.Mock.Values.Cycle.html","title":"Patch.Mock.Values.Cycle","type":"module"},{"doc":"","ref":"Patch.Mock.Values.Cycle.html#advance/1","title":"Patch.Mock.Values.Cycle.advance/1","type":"function"},{"doc":"","ref":"Patch.Mock.Values.Cycle.html#new/1","title":"Patch.Mock.Values.Cycle.new/1","type":"function"},{"doc":"","ref":"Patch.Mock.Values.Cycle.html#next/2","title":"Patch.Mock.Values.Cycle.next/2","type":"function"},{"doc":"","ref":"Patch.Mock.Values.Cycle.html#t:t/0","title":"Patch.Mock.Values.Cycle.t/0","type":"type"},{"doc":"","ref":"Patch.Mock.Values.Scalar.html","title":"Patch.Mock.Values.Scalar","type":"module"},{"doc":"","ref":"Patch.Mock.Values.Scalar.html#advance/1","title":"Patch.Mock.Values.Scalar.advance/1","type":"function"},{"doc":"","ref":"Patch.Mock.Values.Scalar.html#new/1","title":"Patch.Mock.Values.Scalar.new/1","type":"function"},{"doc":"","ref":"Patch.Mock.Values.Scalar.html#next/2","title":"Patch.Mock.Values.Scalar.next/2","type":"function"},{"doc":"","ref":"Patch.Mock.Values.Scalar.html#t:t/0","title":"Patch.Mock.Values.Scalar.t/0","type":"type"},{"doc":"","ref":"Patch.Mock.Values.Sequence.html","title":"Patch.Mock.Values.Sequence","type":"module"},{"doc":"","ref":"Patch.Mock.Values.Sequence.html#advance/1","title":"Patch.Mock.Values.Sequence.advance/1","type":"function"},{"doc":"","ref":"Patch.Mock.Values.Sequence.html#new/1","title":"Patch.Mock.Values.Sequence.new/1","type":"function"},{"doc":"","ref":"Patch.Mock.Values.Sequence.html#next/2","title":"Patch.Mock.Values.Sequence.next/2","type":"function"},{"doc":"","ref":"Patch.Mock.Values.Sequence.html#t:t/0","title":"Patch.Mock.Values.Sequence.t/0","type":"type"},{"doc":"","ref":"Patch.Reflection.html","title":"Patch.Reflection","type":"module"},{"doc":"","ref":"Patch.Reflection.html#find_arities/2","title":"Patch.Reflection.find_arities/2","type":"function"},{"doc":"","ref":"Patch.Reflection.html#find_functions/1","title":"Patch.Reflection.find_functions/1","type":"function"},{"doc":"","ref":"Patch.Supervisor.html","title":"Patch.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Patch.Supervisor.html#child_spec/1","title":"Patch.Supervisor.child_spec/1","type":"function"},{"doc":"Callback implementation for Supervisor.init/1 .","ref":"Patch.Supervisor.html#init/1","title":"Patch.Supervisor.init/1","type":"function"},{"doc":"","ref":"Patch.Supervisor.html#start_link/1","title":"Patch.Supervisor.start_link/1","type":"function"},{"doc":"","ref":"Patch.MissingCall.html","title":"Patch.MissingCall","type":"exception"},{"doc":"","ref":"Patch.UnexpectedCall.html","title":"Patch.UnexpectedCall","type":"exception"},{"doc":"Patch Patch - Ergonomic Mocking for Elixir Patch makes it easy to replace functionality in tests with test specific functionality. Patch augments ExUnit with several utilities that make writing tests in Elixir fast and easy. Patch includes unique functionality that no other mocking library for Elixir provides, Patch's Super Powers .","ref":"readme.html","title":"Patch","type":"extras"},{"doc":"Why use Patch instead of meck, Mock, Mockery, Mox, etc? Patch starts with a very simple idea for how a patched function should work. Patched functions should always return the mock value they are given. Here are the key features of Patch. Easy-to-use and composable interface with sensible defaults. First class support for working with Processes. No testing code in non-test code. In addition to these features which many libraries aspire to, Patch has 3 additional features that no other mocking library for Elixir / Erlang seem to have. These Super Powers are Patch mocks are effective for both local and remote calls. This means a patched function always resolves to the patch. Patch can patch private functions without changing their visibility. Patch makes it possible to test your private functions without changing their visibility via the expose/2 functionality. See the Mockompare companion project for a comparison of Elixir / Erlang mocking libraries. If there is a way to accomplish the following with another library, please open an issue so this section and the comparisons can be updated. For more information about Patch's Super Powers see the Super Powers Documentation","ref":"readme.html#features","title":"Patch - Features","type":"extras"},{"doc":"Installation Quickstart Core Functions Assertions Value Builders Guide Book Support Matrix Limitations Prior Art Changelog","ref":"readme.html#table-of-contents","title":"Patch - Table of Contents","type":"extras"},{"doc":"Add patch to your mix.exs def deps do [ { :patch , &quot;~&gt; 0.6.0&quot; , only : [ :test ] } ] end","ref":"readme.html#installation","title":"Patch - Installation","type":"extras"},{"doc":"After adding the dependency just add the following line to any test module after using your test case use Patch This library comes with a comprehensive suite of unit tests. These tests not only verify that the library is working correctly but are designed so that for every bit of functionality there is an easy to understand example for how to use that feature. Check out the User Tests for examples of how to use each feature. Using Patch adds 10 core functions, 4 assertions, and 7 mock value builders to the test. Core Functions Core functions let us apply patches, patch processes, intercept messages, and query our patched modules. Core Function Description expose/2 Expose private functions as public for the purposes of testing fake/2 Replaces a module with a fake module history/1,2 Returns the call history for a mock inject/3 Injects state into a GenServer listen/3 Intercepts messages to a process and forwards them to the test process patch/3 Patches a function so that it returns a mock value private/1 Macro to call exposed private functions without raising a compiler warning real/1 Resolves the real module for a patched module restore/1 Restores a module to its pre-patched form spy/1 Patches a module so calls can be asserted without changing behavior Assertions Assertions make it easy to assert that a patched module has or has not observed a call. Assertion Description assert_called/1 Asserts that a particular call has occurred on a mocked module assert_any_call/2 Asserts that any call of any arity has occurred on the mocked module for a function name refute_called/1 Refutes that a particular call has occurred on a mocked module refute_any_call/2 Refutes that any call of any arity has occured on the mocked module for a function name Value Builders Patched functions aren't limited to only returning simple scalar values, a host of Value Builders are provided for all kinds of testing scenarios. See the patch documentation for details. Value Builder Description callable/1,2 Callable that will be invoked on every patch invocation, dispatch mode can be customized cycle/1 Cycles through the values provided on every invocation raises/1 Raises a RuntimeException with the given message upon invocation raises/2 Raises the specified Exception with the given attribtues upon invocation scalar/1 Returns the argument as a literal, useful for returning functions sequence/1 Returns the values in order, repeating the last value indefinitely throws/1 Throws the given value upon invocation","ref":"readme.html#quickstart","title":"Patch - Quickstart","type":"extras"},{"doc":"Patch comes with plenty of documentation and a Suite of User Tests that show how to use the library. For a guided tour and deep dive of Patch, see the Guide Book","ref":"readme.html#guide-book","title":"Patch - Guide Book","type":"extras"},{"doc":"Tests automatically run against a matrix of OTP and Elixir Versions, see the ci.yml for details. OTP \\ Elixir 1.7 1.8 1.9 1.10 1.11 1.12 20 ✅ ✅ ✅ N/A N/A N/A 21 ✅ ✅ ✅ ✅ ✅ N/A 22 ✅ ✅ ✅ ✅ ✅ ✅ 23 N/A N/A N/A ✅ ✅ ✅ 24 N/A N/A N/A N/A ✅ ✅","ref":"readme.html#support-matrix","title":"Patch - Support Matrix","type":"extras"},{"doc":"Patch works by recompiling modules, this alters the global execution environment. Since the global execution environment is altered by Patch, Patch is not compatible with async: true .","ref":"readme.html#limitations","title":"Patch - Limitations","type":"extras"},{"doc":"Up to version 0.5.0 Patch was based off the excellent meck library. Patch Super Powers required a custom replacement for meck, Patch.Mock . Patch also takes inspiration from python's unittest.mock.patch for API design.","ref":"readme.html#prior-art","title":"Patch - Prior Art","type":"extras"},{"doc":"See the Changelog","ref":"readme.html#changelog","title":"Patch - Changelog","type":"extras"},{"doc":"Super Powers Patch provides unique features that no other mocking library for Elixir offers. See the Mockompare suite for a comparison of Elixir / Erlang mocking libraries. If there is a way to accomplish the following with another library, please open an issue so this section and the comparisons can be updated. So what are these super powers? Patch mocks are effective for both local and remote calls. This means a patched function always resolves to the patch. Patch can patch private functions without changing their visibility. Patch makes it possible to test your private functions without changing their visibility via the expose/2 functionality.","ref":"super-powers.html","title":"Super Powers","type":"extras"},{"doc":"In Elixir we have two different ways to call a function, local call vs remote call. In a local call, the module is not specified. defmodule Example do def example do collaborator ( ) # No Module, this is a local call end def collaborator do :original end end In a remote call the module is specified, this is most common when calling from one module to another, but can be done within a module if desired. defmodule Example do def example do __MODULE__ . collaborator ( ) # Module specified, this is a remote call end def collaborator do :original end end It is exceedingly common to use local calls when writing a module. The problem comes when mocking a collaborator function. First, why might we want to mock out a collaborator? Here's an example where we might want to skip some functionality. defmodule Example do def save ( thing ) do if valid? ( thing ) do do_save ( thing ) else { :error , :invalid } end end def valid? ( thing ) do [ &amp; Example.Validation . name_not_blank? / 1 , &amp; Example.Validation . token_hash_valid? / 1 , &amp; Example.Validation . flux_capacitor_within_limits? / 1 ] |&gt; Enum . all? ( fn validator -&gt; validator . ( thing ) end ) end defp do_save ( thing ) do DB . insert ( thing ) end end In the unit tests for Example.save/1 we want to test the high level logic of &quot;valid gets saved, invalid gets an error.&quot; This is complicated though because Example.valid?/1 has real validations baked in. A common approach is to create a fixture that can pass the validation rules and one that can't. This is a brittle solution though, it introduces a high degree of coupling between the Example.save/1 tests and the implementation of Example.valid?/1 . A more robust approach is simply to patch out the call to Example.valid?/1 . When we want to test that a valid thing gets saved, we don't have to jump through hoops to get Example.valid?/1 to return true, we can just patch it and tell it to return true. When someone comes along and changes the validation rules in Example.valid?/1 it won't break our Example.save/1 tests, it might break the tests for Example.valid?/1 but that's a much better outcome because the test breaking is directly related to the code being changed. Additionally, in a unit test we would want to isolate the unit from the database. Our Example.do_save/1 method wants to actually write to a database, but this is an implementation detail as far as Example.save/1 is concerned. A common approach in unit testing is to replace external dependencies, like APIs and Databases, with Fakes. A Fake DB could be as complex another copy of the schema actually running on the real database software that's isolated for test data or as simple as an in memory map. In this style of testing, the test author can let the code read and write from the fake datastore and then query to make sure the datastore is in the appropriate state. This approach &quot;over tests&quot; the datastore, which is likely already well tested. A simpler approach is to simply patch out Example.do_save/1 since we only care that it gets called and it's correct functioning should be guaranteed by tests that directly test that function. With Patch, we can mock these functions and have the mocks be effective even though the module is using the common local call pattern. defmodule ExampleTest do use ExUnit.Case use Patch describe &quot;save/1&quot; do test &quot;valid things will be saved&quot; do # Make everything valid patch ( Example , :valid? , true ) # Patch out do_save so we don&#39;t try to hit the database patch ( Example , :do_save , :ok ) assert :ok == Example . save ( :thing ) assert_called Example . do_save ( :thing ) end test &quot;invalid things will not be saved&quot; do # We want to refute the call to do_save/1, so let&#39;s spy the entire module spy ( Example ) # Make everything invalid patch ( Example , :valid? , false ) assert { :error , :invalid } == Example . save ( :thing ) refute_called Example . do_save ( :_ ) end end end","ref":"super-powers.html#local-and-remote-calls","title":"Super Powers - Local and Remote Calls","type":"extras"},{"doc":"Patch allows the test author to patch private functions without doing anything special. Given the following module defmodule Example do def public_function ( a ) do { :ok , private_function ( a ) } end defp private_function ( a ) do { :private , a } end end We can write the following test. defmodule ExampleTest do use ExUnit.Case use Patch test &quot;public_function/1 wraps private_function/1&quot; do patch ( Example , :private_function , :patched ) assert Example . public_function ( :test_argument ) == { :ok , :patched } end end Since Patch guarantees that all calls to a patched function return the mock value, this works as expected. Private functions can be patched just like a public function, but unless they are exposed via expose/2 they don't become public. This means that any other code in the project that might have mistakenly made a call to Example.private_function/1 will fail under test because the visibility is still private. To make a private function public, read on to the next section.","ref":"super-powers.html#patching-private-functions","title":"Super Powers - Patching Private Functions","type":"extras"},{"doc":"Private functions frequently go untested because they are difficult to test. Developers are faced with a few options when they have a private function. Don't test the private function. Test the private function circuitously by calling some public functions. Make a public wrapper for the private function and test that. Change the visibility to public and put a comment with some form of, &quot;This is public just for testing, this function should be treated as though it's private.&quot; Patch provides a new mechanism for testing private functions, expose/2 . With expose/2 the test author can expose any private function to the tests as though it's public. Here's an example. defmodule Example do def public_function ( arg ) do value = private_function ( arg ) if value &lt; 100 do :small else :large end end ## Private defp private_function ( arg ) when arg &lt; 20 do arg * 1000 end defp private_function ( arg ) when arg &lt; 80 do arg - 3 end defp private_function ( arg ) do Integer . floor_div ( arg , 2 ) end end Testing public_function/1 gives us a very coarse measure of if the private_function/1 logic is working correctly. It would be great if we could expose private_function/1 to be able to more directly test this unit. Here's how we can expose this function for testing via expose/2 defmodule ExampleTest do use ExUnit.Case use Patch describe &quot;private_function/1&quot; do test &quot;values less than 20 get magnified by 1000&quot; do expose ( Example , private_function : 1 ) assert Example . private_function ( 10 ) == 10_000 end test &quot;values betwen 20 and 80 are reduced by 3&quot; do expose ( Example , private_function : 1 ) assert Example . private_function ( 50 ) == 47 end test &quot;values greater than or equal to 80 are halved&quot; do expose ( Example , private_function : 1 ) assert Example . private_function ( 120 ) == 60 end end end","ref":"super-powers.html#testing-private-functions","title":"Super Powers - Testing Private Functions","type":"extras"},{"doc":"Check out the documentation for Patch.Mock.Code for more details on how this is accomplished.","ref":"super-powers.html#how-does-this-all-work","title":"Super Powers - How does this all work?","type":"extras"},{"doc":"Change Log","ref":"changelog.html","title":"Change Log","type":"extras"},{"doc":"Minor release to improve the documentation and reduce the scope of imported symbols from Patch.Mock.Value . Improvements ⬆️ - [Documentation] Guide Book broken into Chapters, additional information about core concepts. Features None Bugfixes None Deprecations None Removals ⛔️ - Patch.Mock.Value.advance/1 and Patch.Mock.Value.next/2 used to be imported into the test when use Patch was present. This was an oversight and these two functions are not meant to be called directly by the test author, the imports have been reduced to remove these symbols.","ref":"changelog.html#0-6-1-2021-10-17","title":"Change Log - 0.6.1 (2021-10-17)","type":"extras"},{"doc":"Major internal refactor. This version removes meck as a dependency and implements a Patch specific replacement, Patch.Mock . This allows us to have a new set of functionality that no other mocking library for Elixir / Erlang has today. Patch Mocks can now be said to obey a single simple rule, public or private, local or remote. A patched function always returns the mock value to all callers. Two new bits of functionality make this true. All calls, local or remote, end up intercepted and the mock value returned. Private functions can be mocked. And as a bonus Private functions can be converted into public functions for direct testing. Improvements ⬆️ - [Internal] Patch.Mock introduced to replace meck ⬆️ - [Documentation] README revamped again, new Super Powers documentation and Guide Book. Features 🎁 - Added the expose/2 function to support testing private functions. 🎁 - Added the history/1,2 function so the history of calls to a mock can be retrieved. 🎁 - Added the private/1 macro to prevent compiler warnings when calling private functions. 🎁 - Added the callable/1,2 value builder to create explicit callable mock values. 🎁 - Added the cycle/1 value builder to create a cycle mock values. 🎁 - Added the raises/1 value builder to cause a mocked function to raise a RuntimeError. 🎁 - Added the raises/2 value builder to cause a mocked function to raise any other Exception. 🎁 - Added the scalar/1 value builder to create explicit scalar mock values. 🎁 - Added the sequence/1 value builder to create sequence mock values. 🎁 - Added the throws/1 value builder to cause a mocked function to throw a value. Bugfixes None Deprecations None Removals ⛔️ - [Dependency] meck was removed as a dependency","ref":"changelog.html#0-6-0-2021-10-16","title":"Change Log - 0.6.0 (2021-10-16)","type":"extras"},{"doc":"Better support for mocking erlang modules Improvements ⬆️ - [Internal] patch.release task to simplify releasing new versions of the library ⬆️ - Support for mocking erlang modules (both sticky and non-sticky) Features None Bugfixes 🐞 - Mocking erlang modules actually works now Deprecations None Removals None","ref":"changelog.html#0-5-0-2021-09-17","title":"Change Log - 0.5.0 (2021-09-17)","type":"extras"},{"doc":"Support for working with Processes Improvements ⬆️ - [Testing] Testing Matrix updated to latest versions of Elixir / OTP ⬆️ - [Dependencies] meck updated to 0.9.2 ⬆️ - [Documentation] README revamped Features 🎁 - Added the listen/3 function to support listening to a process's messages 🎁 - Added the inject/3 function to support updating the state of a running process. Bugfixes None Deprecations None Removals None","ref":"changelog.html#0-4-0-2021-08-09","title":"Change Log - 0.4.0 (2021-08-09)","type":"extras"},{"doc":"Support for replacing a module wholesale via the fake/2 function Improvements ⬆️ - [Internal] Patch.Function.for_arity/2 now accepts an anonymous function it will call instead of a term to return. ⬆️ - [Internal] Patch.find_functions/1 and Patch.find_arities/2 use __info__/1 now instead of doing 256 function_exported? checks per function. Features 🎁 - Added the fake/2 function to add support for module fakes. 🎁 - Added the real/1 function so module fakes can call the real module. Bugfixes None Deprecations None Removals None","ref":"changelog.html#0-3-0-2021-07-12","title":"Change Log - 0.3.0 (2021-07-12)","type":"extras"},{"doc":"Removed Arity Limitations Improvements ⬆️ - Removed the arity limitation, can now patch functions of any arity Features 🎁 - Added the assert_any_call/2 and refute_any_call/2 assertion functions Bugfixes None Deprecations None Removals None","ref":"changelog.html#0-2-0-2021-03-03","title":"Change Log - 0.2.0 (2021-03-03)","type":"extras"},{"doc":"Increased Elixir Compatibility Improvements ⬆️ - Relaxed Elixir version requirement down to 1.7 Features None Bugfixes None Deprecations None Removals None","ref":"changelog.html#0-1-2-2021-01-28","title":"Change Log - 0.1.2 (2021-01-28)","type":"extras"},{"doc":"Bugfix Release Improvements ⬆️ - Made the library actually work Features None Bugfixes 🐞 - Bugfix to make the library actually work Deprecations None Removals None","ref":"changelog.html#0-1-1-2020-04-27","title":"Change Log - 0.1.1 (2020-04-27)","type":"extras"},{"doc":"Initial Release Improvements ⬆️ - Patch released to the world. Easy to use and ergonomic Mocking for Elixir. Features 🎁 - patch/3 allows the patching of a module's function with a function. 🎁 - patch/3 allows the patching of a module's function with a static return value. 🎁 - spy/1 allows spying on a module. 🎁 - restore/1 allows removing patches and spies from a module. 🎁 - assert_called/1 allows for asserting that a patched or spied function has been called with the expected pattern of arguments. 🎁 - refute_called/1 allows for refuting that a patched or spied function has been called with the expected pattern of arguments. Bugfixes None Deprecations None Removals None","ref":"changelog.html#0-1-0-2020-04-21","title":"Change Log - 0.1.0 (2020-04-21)","type":"extras"},{"doc":"Chapter 1: Introduction This guide book will walk you through using all the features and functionality of Patch to make great unit tests.","ref":"01-introduction.html","title":"Chapter 1: Introduction","type":"extras"},{"doc":"Patch is founded on One Big Idea Patched functions should always return the mock value they are given. This is how patched functions behave in Patch . Every function is a valid target for patching and once patched the function will always return the mock value given. If you ever feel lost, remember this One Big Idea.","ref":"01-introduction.html#one-big-idea","title":"Chapter 1: Introduction - One Big Idea","type":"extras"},{"doc":"Throughout this guide book we are going to use some common terminology, let's define them. Patch Patch is used as both a verb and a noun. To &quot;patch&quot; a function is to replace it with an alternative implementation. The alternative implemention is the noun form of &quot;patch&quot; sometimes called the &quot;patched function.&quot; patch ( Example , :example , :patched ) Example.example has been &quot;patched&quot; with a &quot;patch&quot; that always returns the value :patched Mock Value The value returned by a &quot;patch&quot; is referred to as the &quot;mock value&quot;. There are a number of types of &quot;mock values&quot; that will be covered in detail in this guide book. Observed Call After a module has been patched, the calls to the module can be observed by Patch . Patch comes with utilities to assert or refute that certain calls have been observed. Calls that happen before the module has been patched are unobserved, the test author can not assert or refute anything about the calls to a module before it has been patched.","ref":"01-introduction.html#terminology","title":"Chapter 1: Introduction - Terminology","type":"extras"},{"doc":"Chapter 2: Patching The most common operation a test author will perform with Patch is, unsurprisingly, patching things. When a module is patched, the patched function will return the mock value provided.","ref":"02-patching.html","title":"Chapter 2: Patching","type":"extras"},{"doc":"The simplest kind of patch is one that just returns a static scalar value on every invocation. defmodule PatchExample do use ExUnit.Case use Patch test &quot;functions can be patched to return a specified value&quot; do # Assertion passes before patching assert &quot;HELLO&quot; == String . upcase ( &quot;hello&quot; ) # The function can be patched to return a static scalar value patch ( String , :upcase , :patched ) # Assertion passes after patching assert :patched == String . upcase ( &quot;hello&quot; ) end end No many how many times we call String.upcase/1 from here on in and no matter what arguments we pass, we will always get back the value :patched .","ref":"02-patching.html#scalar-values","title":"Chapter 2: Patching - Scalar Values","type":"extras"},{"doc":"Modules can also be patched to run custom logic instead of returning a static value defmodule PatchExample do use ExUnit.Case use Patch test &quot;functions can be patched with a replacement function&quot; do # Assertion passes before patching assert &quot;HELLO&quot; == String . upcase ( &quot;hello&quot; ) # The function can be patched to run custom code patch ( String , :upcase , fn s -&gt; String . length ( s ) end ) # Assertion passes after patching assert 5 == String . upcase ( &quot;hello&quot; ) end end Every time we call String.upcase/1 it will run our function and return the length of the input.","ref":"02-patching.html#callable-values","title":"Chapter 2: Patching - Callable Values","type":"extras"},{"doc":"There are other types of values supported by Patch , see Chapter 3: Mock Values Callables with Multiple Arities String.upcase actually comes in 2 arities, String.upcase/1 and String.upcase/2 . In the above we only define a callable that handles arity 1 calls. A first attempt might be to provide multiple clauses in our anonymous function. This code doesn't work # The function can be patched to run custom code patch ( String , :upcase , fn s -&gt; String . length ( s ) s , _ -&gt; String . length ( s ) end ) This code is illegal in Elixir, the compiler will throw a CompileError and explain that you &quot;cannot mix clauses with different arities in anonymous functions.&quot; This is where the callable &quot;dispatch mode&quot; kicks in. By default Patch will use the :apply mode, which calls the function with the same arity as the patched function was called. There is an alternative &quot;dispatch mode&quot; called :list which will pass all the arguments as a single argument, a list of the arguments. This code will work # The function can be patched to run custom code patch ( String , :upcase , callable ( fn [ s | _ ] -&gt; String . length ( s ) end , :list ) So now we have a function that gets a list of arguments. It only ever cares about the first argument so it pattern matches that value out. The second argument to callable/2 defines the &quot;dispatch mode.&quot; Functions as Scalars If functions are always considered callable, how can we patch a function so that it returns a function literal? This can be accomplished by wrapping the function in a call to scalar/1 to turn it into a scalar. defmodule PatchExample do use ExUnit.Case use Patch test &quot;patch returns a function literal&quot; do patch ( Example , :get_name_normalizer , scalar ( &amp; String . downcase / 1 ) ) normalizer = Example . get_name_normalizer ( ) assert normalizer . ( &quot;Patch&quot; ) == &quot;patch&quot; end end","ref":"02-patching.html#other-values","title":"Chapter 2: Patching - Other Values","type":"extras"},{"doc":"patch/3 returns the value that the patch will return which can be useful for later on in the test. Examine this example code for an example defmodule PatchExample do use ExUnit.Case use Patch test &quot;patch returns the patch&quot; do { :ok , expected } = patch ( My.Module , :some_function , { :ok , 123 } ) # ... additional testing code ... assert response . some_function_result == expected end end This allows the test author to combine creating fixture data with patching.","ref":"02-patching.html#ergonomics","title":"Chapter 2: Patching - Ergonomics","type":"extras"},{"doc":"After a patch is applied, all subsequent calls to the module become &quot;Observered Calls&quot; and tests can assert that an expected call has occurred by using the assert_called macro. defmodule PatchExample do use ExUnit.Case use Patch test &quot;asserting calls on a patch&quot; do patch ( String , :upcase , :patched ) assert :patched = String . upcase ( &quot;hello&quot; ) # Assertion passes after patching assert_called String . upcase ( &quot;hello&quot; ) # Assertion passes after call end end assert_called supports the :_ wildcard atom. In the above example the following assertion would also pass. assert_called String . upcase ( :_ ) This can be useful when some of the arguments are complex or uninteresting for the unit test. Tests can also refute that a call has occurred with the refute_called macro. This macro works in much the same way as assert_called and also supports the :_ wildcard atom. defmodule PatchExample do use ExUnit.Case use Patch test &quot;refuting calls on a patch&quot; do patch ( String , :upcase , :patched ) assert &quot;h&quot; == String . at ( &quot;hello&quot; , 0 ) refute_called String . upcase ( &quot;hello&quot; ) end end Asserting / Refuting Multiple Arities If a function has multiple arities that may be called based on different conditions the test author may wish to assert or refute that a function has been called at all without regards to the number of arguments passed. This can be accomplished with the assert_any_call/2 and refute_any_call/2 functions. These functions take two arguments the module and the function name as an atom. defmodule PatchExample do use ExUnit.Case use Patch test &quot;asserting any call on a patch&quot; do patch ( String , :pad_leading , fn s -&gt; s end ) # This formatting call might provide custom padding characters based on # time of day. (This is an obviously constructed example). TimeOfDaySensitiveFormatter . format ( &quot;Hello World&quot; ) assert_any_call String , :pad_leading end end Similarly we can refute any call defmodule PatchExample do use ExUnit.Case use Patch test &quot;refuting any call on a patch&quot; do patch ( String , :pad_leading , fn s -&gt; s end ) assert { :error , :not_a_string } = TimeOfDaySensitiveFormatter . format ( 123 ) refute_any_call String , :pad_leading end end","ref":"02-patching.html#asserting-refuting-calls","title":"Chapter 2: Patching - Asserting / Refuting Calls","type":"extras"},{"doc":"Chapter 3: Mock Values In Chapter 2: Patching we covered two kinds of mock values, Callables and Scalars. There are 5 other kinds of mock values available for use in a test.","ref":"03-mock-values.html","title":"Chapter 3: Mock Values","type":"extras"},{"doc":"Cycle Values will endlessly cycle through a list of return values. When a patched function has a Values.Cycle as its mock value, it will provide the first value in the cycle and then move the first value to the end of the cycle on every invocation. Consider a function patched with cycle([1, 2, 3]) via the following code patch ( Example , :example , cycle ( [ 1 , 2 , 3 ] ) ) Invocation Cycle Before Call Return Value Cycle After Call 1 [1, 2, 3] 1 [2, 3, 1] 2 [2, 3, 1] 2 [3, 1, 2] 3 [3, 1, 2] 3 [1, 2, 3] 4 [1, 2, 3] 1 [2, 3, 1] 5 [2, 3, 1] 2 [3, 1, 2] 6 [3, 1, 2] 3 [1, 2, 3] 7 [1, 2, 3] 1 [2, 3, 1] We could continue the above table forever since the cycle will repeat endlessly. Cycles can contain callable/1,2 , raise/1,2 and throw/1 mock values. We could create a patch that raises a RuntimeError every other call. patch ( Example , :example , cycle ( [ :ok , raises ( &quot;broken&quot; ) ] ) ) This can be helpful for testing retry and backoff constructs, a cycle like this is a good simulation of an unreliable network or dependency.","ref":"03-mock-values.html#cycle-values","title":"Chapter 3: Mock Values - Cycle Values","type":"extras"},{"doc":"Sequence values are similar to cycles, but instead of cycling the list is consumed until only one element is remaining. Once the sequence has only a single element remaining, that element will be returned on all subsequent calls. Consider a function patched with sequence([1, 2, 3]) via the following code patch ( Example , :example , sequence ( [ 1 , 2 , 3 ] ) ) Invocation Sequence Before Call Return Value Sequence After Call 1 [1, 2, 3] 1 [2, 3] 2 [2, 3] 2 [3] 3 [3] 3 [3] 4 [3] 3 [3] 5 [3] 3 [3] We could continue the above table forever since the sequence will continue to return the last value endlessly. Sequences can contain callable/1,2 , raise/1,2 and throw/1 mock values. There is one special behavior of sequence, and that's an empty sequence, which always returns the value nil on every invocation. If the test author would like to simulate an exhaustable sequence, one that returns a set number of items and then responds to every other call with nil , they can simply add a nil as the last element in the sequence patch ( Example , :example , sequence ( [ 1 , 2 , 3 , nil ] ) Invocation Sequence Before Call Return Value Sequence After Call 1 [1, 2, 3, nil] 1 [2, 3, nil] 2 [2, 3, nil] 2 [3, nil] 3 [3, nil] 3 [nil] 4 [nil] nil [nil] 5 [nil] nil [nil]","ref":"03-mock-values.html#sequence-values","title":"Chapter 3: Mock Values - Sequence Values","type":"extras"},{"doc":"When a function can fail by raising an exception we can use raises/1,2 to have the patched function raise. raise/1 creates a special Values.Callable to be used as a mock value. This callable ignores the arguments passed in and unconditionally raises a RuntimeError with the given message. patch ( Example , :example , raises ( &quot;patched&quot; ) ) assert_raise RuntimeError , &quot;patched&quot; , fn -&gt; Example . example ( ) end raise/2 creates a special Values.Callable to be used as a mock value. This callable ignores the arguments passed in and unconditionally raises the specified exception with the given attributes. patch ( Example , :example , raises ( ArgumentError , message : &quot;patched&quot; ) ) assert_raise ArgumentError , &quot;patched&quot; , fn -&gt; Example . example ( ) end","ref":"03-mock-values.html#raises-value","title":"Chapter 3: Mock Values - Raises Value","type":"extras"},{"doc":"When a function can fail by raising an exception we can use throws/1 to have the patched function throw. throws/1 creates a special Values.Callable to be used as a mock value. This callable ignores the arguments passed in and unconditionally throws the given value. patch ( Example , :example , throws ( :patched ) ) assert catch_throw ( Example . example ( ) ) == :patched","ref":"03-mock-values.html#throws-value","title":"Chapter 3: Mock Values - Throws Value","type":"extras"},{"doc":"Chapter 4: Spies and Fakes In Chapter 2: Patching and Chapter 3: Mock Values we saw how we can patch functions to return particular mock values. There are two common cases for patching that have special helpers.","ref":"04-spies-and-fakes.html","title":"Chapter 4: Spies and Fakes","type":"extras"},{"doc":"If a test wishes to assert / refute calls that happen to a module without actually changing the behavior of the module it can simply spy/1 the module. Spies behave identically to the original module but all calls are recorded so assert_called/1 , refute_called/1 , assert_any_called/2 , and refute_any_called/2 work as expected. defmodule PatchExample do use ExUnit.Case use Patch def example ( value ) do String . upcase ( value ) end test &quot;spies can see what calls happen without changing functionality&quot; do spy ( String ) assert &quot;HELLO&quot; == example ( &quot;hello&quot; ) assert_called String . upcase ( &quot;hello&quot; ) end end Fakes Sometimes we want to replace one module with another for testing, for example we might want to replace a module that connects to a real datastore with a fake that stores data in memory while providing the same API. The fake/2,3 functions can be used to replace one module with another. The replacement module can be completely stand alone or can utilize the functionality of the replaced module, it will be made available through use of the real/1 function. defmodule HighLatencyDatabase do @latency System . convert_time_unit ( 20 , :second , :microsecond ) def get ( id ) do { elapsed , response } = :timer . tc ( fn -&gt; Patch . real ( Database ) . get ( id ) end ) induce_latency ( elapsed ) response end defp induce_latency ( elapsed ) when elapsed &lt; @latency do time_to_sleep = System . convert_time_unit ( @latency - elapsed , :microsecond , :millisecond ) Process . sleep ( time_to_sleep ) end defp induce_latency ( _ ) , do : :ok end This fake module uses the real module to actually get the record from the database and then makes sure that a minimum amount of latency, in this case 20 seconds, is introduced before returning the result.","ref":"04-spies-and-fakes.html#spies","title":"Chapter 4: Spies and Fakes - Spies","type":"extras"},{"doc":"Chapter 5: Processes Elixir code frequently runs many processes and a test author often wants to assert about the flow of messages between processes. Patch provides some utilities that make listening to the messages between processes easy.","ref":"05-processes.html","title":"Chapter 5: Processes","type":"extras"},{"doc":"Listeners are processes that sit between the sender process and the target process. The listener process will send a copy of every message to the test process so it can use ExUnit's built in assert_receive , assert_received , refute_receive , and refute_received functions. Listeners are especially useful when working with named processes since they will automatically unregister the named process and take its place. For anonymous processes the inject/3 function is provided to assist in injecting listeners into other processes or the listener can be used in place of the target process when starting consumer processes. Listeners are started with the listen/3 function and each have a tag so that the test process can differentiate which listener has delivered which message. defmodule PatchExample do use ExUnit.Case use Patch test &quot;sharded read replication&quot; do listen ( :shard_a_leader , ShardALeader ) listen ( :shard_a_replica_1 , ShardAReplica1 ) listen ( :shard_a_replica_2 , ShardAReplica2 ) listen ( :shard_b_leader , ShardBLeader ) listen ( :shard_b_replica_1 , ShardBReplica1 ) listen ( :shard_b_replica_2 , ShardBReplica2 ) send ( ShardALeader , { :write , :some_value } ) # Assert the leader gets the message assert_receive { :shard_a_leader , { :write , :some_value } } # Assert that the replicas for Shard A get the message too assert_receive { :shard_a_replica_1 , { :write , :some_value } } assert_receive { :shard_a_replica_2 , { :write , :some_value } } # Assert that Shard A does not try to replicate to Shard B refute_receive { :shard_b_leader , { :write , :some_value } } refute_receive { :shard_b_replica_1 , { :write , :some_value } } refute_receive { :shard_b_replica_2 , { :write , :some_value } } end end GenServer Support Listeners have special support for GenServers. By default a listener will provide the test process with all calls, replies, casts, and messages. Given a listener with the tag :tag the messages from a GenServer are formatted as follows. Client Code Message to Test Process GenServer.call(pid, :message) {:tag, {GenServer, :call, :message, from}} # if capture_replies = true {:tag, {GenServer, :reply, result, from}} GenServer.cast(pid, :message) {:tag, {GenServer, :cast, :message}} During a GenServer.call/3 the listener sits between the client and the server and reports back information to the test process. .------------. .------. .--------. .------. |Test Process| |client| |listener| |server| '------------' '------' '--------' '------' | | GenServer.call(message)| | | | -----------------------&gt; | | | | | | {GenServer, :call, message, from} | | | &lt;- - - - - - - - - - - - - - - - - - - - - - | | | | | | | | GenServer.call(message)| | | | -----------------------&gt; | | | | | | | reply | | | | &lt;----------------------- | | | | | {GenServer, :reply, reply, from} | | | &lt;- - - - - - - - - - - - - - - - - - - - - - | | | | | | | reply | | | | &lt;----------------------- | .------------. .------. .--------. .------. |Test Process| |client| |listener| |server| '------------' '------' '--------' '------'` GenServer.call/3 allows the client to set a timeout, an amount of time to wait for the server to response. The listener does not know how long the original client will wait for a timeout, the test author can provide a :timeout option when spawning the listener to control how long the listener will wait for its GenServer.call/3 . By default the listener will wait 5000ms for each call, the default for GenServer.call/2 . If the test doesn't require the listener to capture replies to GenServer.call then the :capture_replies option can be set to false. When this option is false the listener will simply forward the call onto the server. Refer to the following diagram for details on how this works. .------------. .------. .--------. .------. |Test Process| |client| |listener| |server| '------------' '------' '--------' '------' | | GenServer.call(message)| | | | -----------------------&gt; | | | | | | {GenServer, :call, message, from} | | | &lt;- - - - - - - - - - - - - - - - - - - - - - | | | | | | | | send(:&quot;$gen_call&quot;, from, message)| | | | ---------------------------------&gt; | | | | | | | reply | | | &lt;---------------------------------------------------------- .------------. .------. .--------. .------. |Test Process| |client| |listener| |server| '------------' '------' '--------' '------' Target Monitoring Listeners will automatically monitor the target process they are listening to. If the target process goes :DOWN the listener will deliver a tagged {:DOWN, reason} message to the test process and then exit.","ref":"05-processes.html#listeners","title":"Chapter 5: Processes - Listeners","type":"extras"},{"doc":"When working with processes in test code it is sometimes necessary to change the state of a running GenServer. Common use cases for injecting state into a GenServer are to set up some fixture data, update a configuration value, or replace a target pid with a listener from the previous section. inject/3 is a helper that handles some common issues when updating state. defmodule PatchExample do use ExUnit.Case use Patch test &quot;state can be updated&quot; do { :ok , pid } = Target . start_link ( :initial_value ) assert :initial_value == Target . get_value ( pid ) inject ( pid , [ :value ] , :updated_value ) assert :updated_value == Target . get_value ( pid ) end end inject/3 accepts a GenServer.server a list of keys like one would use for put_in and then a value to inject into the processes state.","ref":"05-processes.html#injecting","title":"Chapter 5: Processes - Injecting","type":"extras"}]